/*
 * Copyright (c) HengShanCompany 2021. All rights reserved.
 * Description: Bl31 hibernate Header files
 * Author : Hengshan-BSP
 * Create : 2021/4/10
 */

#ifndef __BL31_HIBERNATE_H__
#define __BL31_HIBERNATE_H__

struct hibernate_meminfo_t {
    /* pyhs addr of kernel and bl31 shamre memory */
    phys_addr_t paddr;
    /* addr size of kernel and bl31 shamre memory */
    u64 addr_size;
    /* virt addr of kernel and bl31 shamre memory */
    void *smem_vaddr;
    /* virt addr of kernel memory for kernel management */
    void *kmem_vaddr;
};

#ifdef CONFIG_BL31_HIBERNATE
int bl31_hibernate_freeze(void);
int bl31_hibernate_restore(void);
struct hibernate_meminfo_t *get_bl31_hibernate_mem_info(void);
#else
static inline int bl31_hibernate_freeze(void) 
{ 
    return 0; 
}
static inline int bl31_hibernate_restore(void) 
{ 
    return 0; 
}
static inline struct hibernate_meminfo_t *get_bl31_hibernate_mem_info(void) 
{ 
    return NULL; 
}
#endif

#endif /* __BL31_HIBERNATE_H__ */
