/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (c) HengShanCompany 2021-2021. All rights reserved.
 * Description: dma-buf extended Interfaces
 * Author: HengShan
 * Create: 2021-04-24
 */

#ifndef DMA_BUF_EXT_H
#define DMA_BUF_EXT_H

#include <linux/dma-buf.h>

#define IOMMU_ERROR_ADDR	(0)
int ext_dma_buf_fd(struct dma_buf *dmabuf, int flags);
dma_addr_t ext_dma_buf_nssmmu_map(struct dma_buf *dmabuf, unsigned long page_num);
int ext_dma_buf_nssmmu_unmap(struct dma_buf *dmabuf,
							unsigned long page_num,
							dma_addr_t iova);
dma_addr_t ext_dma_buf_secsmmu_map(struct dma_buf *dmabuf,
								  unsigned long page_num);
int ext_dma_buf_secsmmu_unmap(struct dma_buf *dmabuf,
							 unsigned long page_num,
							 dma_addr_t iova);
dma_addr_t ext_dma_buf_phy_get(struct dma_buf *dmabuf);
void ext_dma_buf_free(struct dma_buf *dmabuf);

#endif // DMA_BUF_EXT_H
