/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (c) HengShanCompany 2021-2021. All rights reserved.
 * Description: dma-buf extended Interfaces
 * Author: HengShan
 * Create: 2021-04-24
 */

#ifndef __IOMMU_EXT_H__
#define __IOMMU_EXT_H__

#include <linux/iommu.h>

#ifdef CONFIG_IOMMU_API

extern int iommu_map_range(struct iommu_domain *domain, unsigned long iova,
		    struct scatterlist *sg, size_t size, int prot);
extern size_t iommu_unmap_range(struct iommu_domain *domain, unsigned long iova,
				size_t size);
extern int iommu_map_tile(struct iommu_domain *domain, unsigned long iova,
		   struct scatterlist *sg, size_t size, int prot,
		   struct tile_format *format);
extern int iommu_unmap_tile(struct iommu_domain *domain, unsigned long iova,
		     size_t size);
extern int iommu_get_pgtbl_base(struct iommu_domain *domain,
				unsigned long iova_start, unsigned long *ptb_base,
				unsigned long *iova_base);
extern int iommu_domain_get_attr_ext(struct iommu_domain *domain,
			  enum iommu_attr attr, void *data);

#else /* CONFIG_IOMMU_API */

static inline int iommu_get_pgtbl_base(struct iommu_domain *domain,
				       unsigned long iova_start, unsigned long *ptb_base,
				       unsigned long *iova_base)
{
	return -EINVAL;
}

#endif /* CONFIG_IOMMU_API */

#endif /* __IOMMU_EXT_H__ */
