/*
 * Copyright (c) HengShanCompany 2016-2020. All rights reserved.
 * Description: kapi header
 * Author: HengShan
 * Create: 2020-4-14
 */

#ifndef UAPIH
#define UAPIH

#include <linux/types.h>

struct pcie_alloc_ctrl_t {
	struct gen_pool *pool;
	char *viraddr; /* virtual address */
	phys_addr_t  phyaddr; /* phy address */
	size_t size;
};

#define KAPI_GET_RAM_SIZE       1
#define KAPI_GET_CMA_SIZE       2
#define KAPI_GET_MMZ_SIZE       3
/**
 * get memory size information, such CMA size, RAM size.
 *
 * param:
 *   size    specify size,
 *   flags   what size you want get.
 *           KAPI_GET_RAM_SIZE - get ram size, unit is 1M
 *           KAPI_GET_CMA_SIZE - get cma size, unit is 1M
 *           KAPI_GET_MMZ_SIZE - get mmz size, unit is 1M
 * retval:
 *   0       success
 *   other   fail.
 */
int get_mem_size(unsigned int *size, int flags);

/*
 * get ddr size/start, unit is bytes
 */
unsigned long get_dram_size(void);
unsigned long get_dram_start(void);

/* ARBITRARY:  SRAM allocations are multiples of this 2^N size */
#define SRAM_GRANULARITY	512

char *ultohstr(u64 size, char *str, int len);
/******************************************************************************/

#include <linux/hengshan/cputable.h>


#endif /* UAPIH */
