/*
 * Copyright (c) CompanyNameMagicTag Co., Ltd. 2019-2019. All rights reserved.
 * Description: rdr_pstore.h
 * Author: BSP
 * Create: 2020-1-2
 */

#ifndef __BB_PSTORE_H__
#define __BB_PSTORE_H__

#ifdef CONFIG_MNTN_BB
void rdr_save_pstore_log(const char *name, const int name_len, const void *data, size_t size);
void rdr_free_persist_store(void);
void rdr_create_pstore_entry(void);
void rdr_remove_pstore_entry(void);
void persist_store_mem_map(const char *name, void *vaddr);
void persist_store_mem_unmap(void);
void *persist_store_lmsg_vaddr(void);
void *persist_store_pmsg_vaddr(void);
#else
static inline void rdr_save_pstore_log(const char *name, const int name_len, const void *data, size_t size)
{
	return;
}
static inline void rdr_free_persist_store(void)
{
	return;
}
static inline void rdr_create_pstore_entry(void)
{
	return;
}
static inline void rdr_remove_pstore_entry(void)
{
	return;
}
static inline void persist_store_mem_map(const char *name, void *vaddr)
{
	return;
}
static inline void persist_store_mem_unmap(void)
{
	return;
}
static inline void *persist_store_lmsg_vaddr(void)
{
	return NULL;
}
static inline void *persist_store_pmsg_vaddr(void)
{
	return NULL;
}
#endif

#endif /* __BB_PSTORE_H__ */
