/*
 * Copyright (c) CompanyNameMagicTag Co., Ltd. 2019-2019. All rights reserved.
 * Description: util.h
 * Author: BSP
 * Create: 2020-1-2
 */

#ifndef __MACH_UTIL_H__
#define __MACH_UTIL_H__

#include <linux/fs.h>
#include <linux/proc_fs.h>
#include <linux/sysctl.h>
#include <mntn/platform/mntn_public_interface.h>

#define PBUF_MAXSIZE (128)

int check_mntnctl(int feature);
u32 atoi(char *s);
struct proc_dir_entry *mntn_create_root_proc_dir(const char *name);
struct proc_dir_entry *mntn_create_root_proc_entry(const char *name, mode_t mode,
	const struct file_operations *proc_fops, void *data);
void mntn_remove_root_proc_entry(const char *name);

struct proc_dir_entry *mntn_create_stats_proc_entry(const char *name, mode_t mode,
	const struct file_operations *proc_fops, void *data);
void mntn_remove_stats_proc_entry(const char *name);

struct proc_dir_entry *mntn_create_memory_proc_entry(const char *name, mode_t mode,
	const struct file_operations *proc_fops, void *data);
void mntn_remove_memory_proc_entry(const char *name);

struct proc_dir_entry *mntn_create_log_proc_entry(const char *name, mode_t mode,
	const struct file_operations *proc_fops, void *data);
void mntn_remove_log_proc_entry(const char *name);

struct proc_dir_entry *mntn_create_pstore_proc_entry(const char *name, mode_t mode,
	const struct file_operations *proc_fops, void *data);
void mntn_remove_pstore_proc_entry(const char *name);

struct proc_dir_entry *mntn_create_extend_proc_entry(const char *name,
	mode_t mode, const struct file_operations *proc_fops, void *data);
void mntn_remove_extend_proc_entry(const char *name);

struct proc_dir_entry *mntn_create_platform_proc_entry(const char *name,
	mode_t mode, const struct file_operations *proc_fops, void *data);
void mntn_remove_platform_proc_entry(const char *name);

struct proc_dir_entry *mntn_create_mntnctl_proc_entry(const char *name,
	mode_t mode, const struct file_operations *proc_fops, void *data);
void mntn_remove_mntnctl_proc_entry(const char *name);

#endif

