#!/bin/bash

#set -x

if [ $1 == "-h" ]; then
	echo 'usage:'
	echo '-h for help.'
	echo '-c local compile package.'
	echo '-l load to ppa, and release version.'
	exit
fi

if [ $1 == "-l" ]; then
	echo "load to ppa ... ..."

	make mrproper ARCH=arm64 -j8
	git clean -xdf
	make distclean -j8
	git checkout debian
	cp debian.master/changelog-panguw debian.master/changelog
	cp debian.master/rules.d/arm64-pangum900.mk debian.master/rules.d/arm64.mk
	git checkout drivers/pangum900_drv/
	fakeroot ./debian/rules clean
	echo -n `git rev-parse HEAD` > .sourceversion
	debuild --no-tgz-check -sa -S
	changelog=`dpkg-parsechangelog -ldebian/changelog -o0 -c0 | sed -ne 's/^Version: *//p'`
	dput devppa:huanglei/kylin/pangum900 ../linux_${changelog}_source.changes
	git checkout debian.master/changelog debian.master/rules.d/arm64.mk
	exit
fi

echo "local compile package ... ..."
make mrproper ARCH=arm64 -j8
make distclean -j8
cp debian.master/changelog-panguw debian.master/changelog
cp debian.master/rules.d/arm64-pangum900.mk debian.master/rules.d/arm64.mk
git checkout drivers/pangum900_drv/
fakeroot ./debian/rules clean
dpkg-buildpackage -us -uc -b -d
git checkout debian.master/changelog debian.master/rules.d/arm64.mk
